// pac_i8028UW_Basic_Info.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "..\lib\pac_i8028U.h"
#pragma comment(lib,"..\\lib\\pac_i8028U.lib")



int _tmain(int argc, _TCHAR* argv[])
{
	int ch, ret=-1, i,slot=-1;
	char act;
	char GainStr[6][10]={"0 ~ 5V", "0 ~ 10V", "+/- 5V", "+/- 10V", "4 ~ 20mA", "0 ~ 20mA"};
	short gain =0;
	float fAO=0;
	short oVal;
	unsigned short gVal;
	char LibDate[20];
	short LibVer=0;
	short FarmVer=0;

	for(i=0;i< 8;i++)
	{
		ret = pac_i8028U_Init(i);
		if(ret== 0)
		{
			slot = i;
			LibVer=pac_i8028U_GetLibVersion();
			pac_i8028U_GetLibDate(LibDate);
			pac_i8028U_GetFirmwareVersion(slot,&FarmVer);

			
			printf("I-8028UW on slot %d \n",slot);
			printf("Library Version %04X \n",LibVer);
			printf("Library Build Date %s \n",LibDate);
			printf("Farmware Version %d \n",FarmVer);
			break;
		}
	}
	if(slot ==-1)
	{
		printf("There is no I-8028UW on the backplane\n");
		getchar();
		getchar();
		return 0;
	}
	while(1)
	{
		printf("Select Output Range : \n");
		for(i=0;i<6;i++)
			printf("%d : %s \n",i,GainStr[i]);
		// Set gain
		scanf("%d", &gain);
		if(gain >5 || gain <0)
		{
			printf("invalid input\n");
			return 0;
		}
		
		if(gain>3)
			printf("Please make sure the Jumper is in current operation\n");
		else
			printf("Please make sure the Jumper is in voltage operation\n");
		// Set output value
		printf("Set AO value, between %s \n", GainStr[gain]);
		scanf("%f", &fAO);
		// Set output channel
		printf("Set output channel : \n");
		printf("\t For I-8028UW Channel index 0~7  \n");
		printf("\t For I-8024UW Channel index 0~3  \n");
		scanf("%d", &ch);
		pac_i8028U_ReadAO_GainOffset(slot,ch,gain,&gVal,&oVal);
		pac_i8028U_WriteAO(slot,  ch , gain,  fAO);
		printf("CH %d ,Range %s ,Gain %u ,Offset %d \nOutput Value = AO %7.3f \n",ch,GainStr[gain],gVal,oVal,fAO);
		
		printf("Press 'q' Or 'Q' to Exit.\nOr else to repeat again\n\n");
		scanf(" %c", &act);
		if(act=='q' || act =='Q')
			return 0;
	}
}

